"use strict";
exports.__esModule = true;
exports.redLive = exports.redLiveSubAfter = exports.redLiveSubBefore = void 0;
var redLiveCallbacksStoreBefore = {};
var redLiveCallbacksStoreAfter = {};
var bindFnOnType = function (actionType, callback, store) {
    if (typeof store[actionType] === 'undefined')
        store[actionType] = [];
    store[actionType].push(callback);
};
var redLiveSubBefore = function (actionType, callback) {
    if (Array.isArray(actionType)) {
        actionType.forEach(function (type) { return bindFnOnType(type, callback, redLiveCallbacksStoreBefore); });
    }
    else {
        bindFnOnType(actionType, callback, redLiveCallbacksStoreBefore);
    }
};
exports.redLiveSubBefore = redLiveSubBefore;
var redLiveSubAfter = function (actionType, callback) {
    if (Array.isArray(actionType)) {
        actionType.forEach(function (type) { return bindFnOnType(type, callback, redLiveCallbacksStoreAfter); });
    }
    else {
        bindFnOnType(actionType, callback, redLiveCallbacksStoreAfter);
    }
};
exports.redLiveSubAfter = redLiveSubAfter;
var redLive = function () { return function (next) { return function (action) {
    if (typeof redLiveCallbacksStoreBefore[action.type] !== 'undefined') {
        redLiveCallbacksStoreBefore[action.type].forEach(function (f) { return f(action); });
    }
    var result = next(action);
    if (typeof redLiveCallbacksStoreAfter[action.type] !== 'undefined') {
        redLiveCallbacksStoreAfter[action.type].forEach(function (f) { return f(action); });
    }
    return result;
}; }; };
exports.redLive = redLive;
